/*{̧DoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief AVRpPID
 *
 * UPIDBInit_PID()P/I/D^邱ƂɂĐݒ肵AԊuli
 * [̂PID_DATA\̂gpĂB
 *
 * - ̧		: pid.c
 * - ߲		: IAR EWAAVR 4.11A
 * - x޲	: SĂAVR޲gpł܂B
 * - pLq	: AVR221 - UPID
 *
 * \author		Atmel Corporation: http://www.atmel.com \n
 *				xEҰ: avr@atmel.com
 *
 * $Name$
 * $Revision: 456 $
 * $RCSfile$
 * $Date: 2006-02-16 12:46:13 +0100 (to, 16 feb 2006) $
 *****************************************************************************/

#include "pid.h"
#include "stdint.h"

/*! \brief PID퍀ڏ
 *
 *  PIDZ@@ɂĎgpϐ̏
 *
 *  \param p_factor	ፀ
 *  \param i_factor	ϕ
 *  \param d_factor	
 *  \param pid		PIDԂ\
 */
void pid_Init(int16_t p_factor, int16_t i_factor, int16_t d_factor, struct PID_DATA *pid)
{ // PID퍀ڏݒ
	// PID䕔pl
	pid->sumError = 0;										// ϕł̌덷̑a
	pid->lastProcessValue = 0;								// l̔p̍ŏIl
	// PIDHp萔
	pid->P_Factor = p_factor;								// (~100)ᒲ萔
	pid->I_Factor = i_factor;								// (~100)ϕ萔
	pid->D_Factor = d_factor;								// (~100)萔
	// 邽߂̐
	pid->maxError = MAX_INT / (pid->P_Factor + 1);			// h~ő勖e덷
	pid->maxSumError = MAX_I_TERM / (pid->I_Factor + 1);	// h~ő勖ea덷
}

/*! \brief PID䉉Z@
 *
 *  ݒ_AlAPIDԂo͌vZ
 *
 *  \param setPoint		vꂽl
 *  \param processValue	肳ꂽl
 *  \param pid_st		PIDԍ\
 */
int16_t pid_Controller(int16_t setPoint, int16_t processValue, struct PID_DATA *pid_st)
{
	int16_t error, p_term, d_term;
	int32_t i_term, ret, temp;

	error = setPoint - processValue;					// vlƑlԂ̌덷擾

	// ፀvZƌ덷ꐧ
	if (error > pid_st->maxError){						// ̕e덷zŁA
		p_term = MAX_INT;								// ፀPx^̐̍őlɐ
	}
	else if (error < -pid_st->maxError){				// ̕e덷zŁA
		p_term = -MAX_INT;								// ፀPx^̍̕őlɐ
	}
	else{												// xŁA
		p_term = pid_st->P_Factor * error;				// ፀ擾
	}
	// ϕvZƐϕ\
	temp = pid_st->sumError + error;					// 񑍘aꎞϐɎ擾
	if(temp > pid_st->maxSumError){						// ̕ea덷zŁA
		i_term = MAX_I_TERM;							// ϕp̔{x^̐̍őlɐ
		pid_st->sumError = pid_st->maxSumError;			// 񑍘aƂĐ̕ea덷ݒ
	}
	else if(temp < -pid_st->maxSumError){				// ̕ea덷zŁA
		i_term = -MAX_I_TERM;							// ϕp̔{x^̍̕őlɐ
		pid_st->sumError = -pid_st->maxSumError;		// 񑍘aƂĕ̕ea덷ݒ
	}
	else{												// xŁA
		pid_st->sumError = temp;						// 񑍘aXV
		i_term = pid_st->I_Factor * pid_st->sumError;	// ϕ擾
	}
	// vZ
	d_term = pid_st->D_Factor * (pid_st->lastProcessValue - processValue);
	pid_st->lastProcessValue = processValue;			// ŏIlXV

	ret = (p_term + i_term + d_term) / SCALING_FACTOR;
	if(ret > MAX_INT){									// ʂ̕Px^őlzŁA
		ret = MAX_INT;									// ʂƂĐ̕Px^őlݒ
	}
	else if(ret < -MAX_INT){							// ʂ̕Px^őlzŁA
		ret = -MAX_INT;									// ʂƂĕ̕Px^őlݒ
	}
	return((int16_t)ret);								// ʂƋɕA
}

/*! \brief ϕؾ
 *
 *  {֐ĂяoPID̐ϕؾĂ܂B
 */
void pid_Reset_Integrator(pidData_t *pid_st)
{
	pid_st->sumError = 0;								// 덷a
}
